﻿# -*- coding: utf-8 -*-
"""
/***************************************************************************
 psPlot
                                 A QGIS plugin
 psPlot
                             -------------------
        begin                : 2016-07-21
        copyright            : (C) 2016 by GeoLog / www.geolog.kr
        email                : kju7755@gmail.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
"""

# Import the PyQt and QGIS libraries
from PyQt4.QtCore import *
from PyQt4.QtGui import *
from PyQt4 import uic

from qgis.core import *
from qgis.gui import *
from qgis.utils import *

import resources_rc
import os.path
import os, time
import sys
    
import ctypes  # An included library with Python install.
import _winreg as wreg  #windows registry
MessageBox = ctypes.windll.user32.MessageBoxW

from commands import *

from pnlPlot import pnlPlot

#PoSS=====================
sys.path.append(os.path.dirname(__file__) + "/.")
sys.path.append(os.path.dirname(__file__) + "/template")


class Main:

    def __init__(self, iface):
        # Save reference to the QGIS interface
        self.iface = iface

        # initialize plugin directory
        self.plugin_dir = os.path.dirname(__file__)

        # initialize locale
        locale = QSettings().value("locale/userLocale")[0:2]
        localePath = os.path.join(self.plugin_dir, 'i18n', 'PoSS_{}.qm'.format(locale))

        if os.path.exists(localePath):
            self.translator = QTranslator()
            self.translator.load(localePath)

            if qVersion() > '4.3.3':
                QCoreApplication.installTranslator(self.translator)

        # Create the dialog (after translation) and keep reference
        self.dlgPlot = pnlPlot(self.iface)

        # Declare instance attributes
        self.actions = []
        self.menu = self.tr(u'&possPlot')
        self.toolbar = self.iface.addToolBar('possPlot')
        self.toolbar.setObjectName('possPlot')
        
    def initGui(self):
        icon_path = ':/plugins/possPlot/print_r.png'
        self.add_action(
            icon_path,
            text=self.tr('possPlot'),
            callback=self.run,
            parent=self.iface.mainWindow())
        
    def unload(self):
        settings = QSettings("PoSS", "possPlot")
        settings.setValue("title", self.dlgPlot.txtTitle.text())
        settings.setValue("template", self.dlgPlot.cboTemplate.currentText())
        settings.setValue("pdfPath", self.dlgPlot.txtPdfFolder.text())
        settings.setValue("pdfCheck", self.dlgPlot.radToPdf.isChecked())
        settings.setValue("printerName", self.dlgPlot.cboPrinter.currentText())
        self.dlgPlot.removeEventFilter(self.dlgPlot)    #close 후 hide 이벤트 추가 발생하여 에러나는 경우 방지를 위해
        self.dlgPlot.close()
        
    def tr(self, message):
        # noinspection PyTypeChecker,PyArgumentList,PyCallByClass
        return QCoreApplication.translate('possPlot', message)

    def add_action(
        self,
        icon_path,
        text,
        callback,
        enabled_flag=True,
        add_to_menu=True,
        add_to_toolbar=True,
        status_tip=None,
        whats_this=None,
        parent=None):

        icon = QIcon(icon_path)
        action = QAction(icon, text, parent)
        action.triggered.connect(callback)
        action.setEnabled(enabled_flag)

        if status_tip is not None:
            action.setStatusTip(status_tip)

        if whats_this is not None:
            action.setWhatsThis(whats_this)

        if add_to_toolbar:
            self.toolbar.addAction(action)

        if add_to_menu:
            self.iface.addPluginToMenu(
                self.menu,
                action)

        self.actions.append(action)

        return action    

    def run(self):
        """Run method that performs all the real work"""
        # show the dialog
        self.dlgPlot.show()
        # Run the dialog event loop
                
 